//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Grids.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include "CPort.hpp"
#include "CPortCtl.hpp"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TImage *ArrayModelImage;
        TLabel *ObstacleAmmountInfoLabel;
        TButton *GenerateModelButton;
        TEdit *ObstacleAmmountEdit;
        TEdit *XDestinationEdit;
        TEdit *YDestinationEdit;
        TLabel *XDestinationPosInfoLabel;
        TLabel *YDestinationPosInfoLabel;
        TImage *ArrayImage;
        TButton *InitializeButton;
        TImage *RobotImage;
        TGroupBox *GroupBox1;
        TLabel *DistanceInfoLabel;
        TLabel *DistanceLabel;
        TLabel *MinStepsInfoLabel;
        TLabel *MinStepsLabel;
        TButton *SuggestNextStepGeneticButton;
        TMemo *ExplanationMemo;
        TImage *SmallSituationImage;
        TButton *ExecuteStepButton;
        TRadioButton *SimulateRadioButton;
        TRadioButton *RealityRadioButton;
        TCheckBox *AutoStepCheckBox;
        TTimer *AutoStepTimer;
        TTrackBar *AutoStepSpeedTrack;
        TImage *ProgressGraphImage;
        TLabel *StepCounterAxisLabel;
        TLabel *StepCounterLabel;
        TButton *LoadArrayModelButton;
        TOpenDialog *FileOpenDialog;
        TButton *LoadGenotypeButton;
        TStringGrid *GenotypeGrid;
        TListView *LogListView;
        TLabel *CodeInfoLabel;
        TLabel *CodeLabel;
        TLabel *GenotypeModifyInfoLabel;
        TLabel *ModifyAmmountLabel;
        TButton *SaveArrayModelButton;
        TSaveDialog *FileSaveDialog;
        TGroupBox *RecoveryGroup;
        TRadioButton *RecoveryMethod0;
        TRadioButton *RecoveryMethod1;
        TRadioButton *RecoveryMethod2;
        TButton *InitializeGenotypeButton;
        TButton *TestArrayModel;
        TRadioButton *RecoveryMethod3;
        TGroupBox *PrimaryMethodGroup;
        TStringGrid *StringGrid1;
        TButton *GenerateGenotypeButton;
        TRadioButton *PrimaryMethod1;
        TRadioButton *PrimaryMethod2;
        TButton *SuggestNextStepGradientButton;
        TGroupBox *MetricsMethodGroup;
        TRadioButton *Metrics1;
        TRadioButton *Metrics2;
        TRadioButton *Metrics4;
        TButton *SuggestStep;
        TRadioButton *Metrics3;
        TCheckBox *BlindHolesCheckBox;
        TRadioButton *PrimaryMethod3;
        TButton *SuggestNextStepTemporaryButton;
        TLabel *SpeedInfoLabel;
        TButton *LeftButton;
        TButton *RightButton;
        TButton *DownButton;
        TListBox *ListBox1;
        TCheckBox *ZonesCheckBox;
        TButton *HideModelButton;
        TButton *UpButton;
        TRadioButton *PrimaryMethod0;
        TButton *SuggestNextStepRandomButton;
        TButton *SaveAsImageButton;
        TMainMenu *MainMenu1;
        TMenuItem *Sbor1;
        TMenuItem *Inicializcia1;
        TMenuItem *Koniec1;
        TMenuItem *Bludisko1;
        TMenuItem *Genotyp1;
        TMenuItem *Vbermetdy1;
        TMenuItem *Npoveda1;
        TMenuItem *Nahrajbludisko1;
        TMenuItem *Ulobludisko1;
        TMenuItem *Ulobludiskoakoobrzok1;
        TMenuItem *Otestujbludisko1;
        TMenuItem *Nahrajgenotyp1;
        TMenuItem *Inicializujgenotyp1;
        TMenuItem *Generujnhodngenotyp1;
        TMenuItem *polozka1;
        TMenuItem *Zotaveniesazozacyklenia1;
        TMenuItem *Metrikapredoasncie1;
        TMenuItem *Nhodnpohybopilec1;
        TMenuItem *Znalostitypugenotyp1;
        TMenuItem *Pohybvsmeregradientu1;
        TMenuItem *Vobadoasnchcieov1;
        TMenuItem *Nepouva1;
        TMenuItem *Rotciagnov1;
        TMenuItem *Nhodnmodifikciagnov1;
        TMenuItem *Vobadoasnhociea1;
        TMenuItem *Vzdialenoskrobotovi1;
        TMenuItem *Vzdialenoskcieu1;
        TMenuItem *Sumavzdialenostkrobotoviakcieu1;
        TMenuItem *Nhodnebezmetriky1;
        TMenuItem *Ovldanie1;
        TMenuItem *Oprograme1;
        TMenuItem *toggleitem;
        TComPort *ComPort1;
        TTimer *RealTimer;
        TMenuItem *Popispolokbludiska1;
        TTimer *AutoStepTimerReal;
        TTimer *ReleaseTimer;
        TButton *Button1;
        void __fastcall ArrayModelImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall GenerateModelButtonClick(TObject *Sender);
        void __fastcall ObstacleAmmountEditKeyPress(TObject *Sender,
          char &Key);
        void __fastcall ObstacleAmmountEditExit(TObject *Sender);
        void __fastcall XDestinationEditKeyPress(TObject *Sender,
          char &Key);
        void __fastcall XDestinationEditExit(TObject *Sender);
        void __fastcall YDestinationEditKeyPress(TObject *Sender,
          char &Key);
        void __fastcall YDestinationEditExit(TObject *Sender);
        void __fastcall InitializeButtonClick(TObject *Sender);
        void __fastcall SuggestNextStepGeneticButtonClick(TObject *Sender);
        void __fastcall ExecuteStepButtonClick(TObject *Sender);
        void __fastcall AutoStepTimerTimer(TObject *Sender);
        void __fastcall LoadArrayModelButtonClick(TObject *Sender);
        void __fastcall LoadGenotypeButtonClick(TObject *Sender);
        void __fastcall GenotypeGridSelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall SaveArrayModelButtonClick(TObject *Sender);
        void __fastcall RecoveryMethod0Click(TObject *Sender);
        void __fastcall RecoveryMethod1Click(TObject *Sender);
        void __fastcall RecoveryMethod2Click(TObject *Sender);
        void __fastcall InitializeGenotypeButtonClick(TObject *Sender);
        void __fastcall TestArrayModelClick(TObject *Sender);
        void __fastcall RecoveryMethod3Click(TObject *Sender);
        void __fastcall RecoveryMethod4Click(TObject *Sender);
        void __fastcall GenerateGenotypeButtonClick(TObject *Sender);
        void __fastcall SuggestNextStepGradientButtonClick(TObject *Sender);
        void __fastcall PrimaryMethod1Click(TObject *Sender);
        void __fastcall PrimaryMethod2Click(TObject *Sender);
        void __fastcall Metrics1Click(TObject *Sender);
        void __fastcall Metrics2Click(TObject *Sender);
        void __fastcall Metrics4Click(TObject *Sender);
        void __fastcall SuggestStepClick(TObject *Sender);
        void __fastcall Metrics3Click(TObject *Sender);
        void __fastcall PrimaryMethod3Click(TObject *Sender);
        void __fastcall SuggestNextStepTemporaryButtonClick(
          TObject *Sender);
        void __fastcall ForwardButtonClick(TObject *Sender);
        void __fastcall RightButtonClick(TObject *Sender);
        void __fastcall DownButtonClick(TObject *Sender);
        void __fastcall LeftButtonClick(TObject *Sender);
        void __fastcall HideModelButtonClick(TObject *Sender);
        void __fastcall UpButtonClick(TObject *Sender);
        void __fastcall PrimaryMethod0Click(TObject *Sender);
        void __fastcall SuggestNextStepRandomButtonClick(TObject *Sender);
        void __fastcall SaveAsImageButtonClick(TObject *Sender);
        void __fastcall Inicializcia1Click(TObject *Sender);
        void __fastcall Koniec1Click(TObject *Sender);
        void __fastcall Nahrajbludisko1Click(TObject *Sender);
        void __fastcall Ulobludisko1Click(TObject *Sender);
        void __fastcall Ulobludiskoakoobrzok1Click(TObject *Sender);
        void __fastcall Otestujbludisko1Click(TObject *Sender);
        void __fastcall Nahrajgenotyp1Click(TObject *Sender);
        void __fastcall Inicializujgenotyp1Click(TObject *Sender);
        void __fastcall Generujnhodngenotyp1Click(TObject *Sender);
        void __fastcall Nhodnpohybopilec1Click(TObject *Sender);
        void __fastcall Znalostitypugenotyp1Click(TObject *Sender);
        void __fastcall Pohybvsmeregradientu1Click(TObject *Sender);
        void __fastcall Vobadoasnchcieov1Click(TObject *Sender);
        void __fastcall Nepouva1Click(TObject *Sender);
        void __fastcall Rotciagnov1Click(TObject *Sender);
        void __fastcall Nhodnmodifikciagnov1Click(TObject *Sender);
        void __fastcall Vobadoasnhociea1Click(TObject *Sender);
        void __fastcall Vzdialenoskrobotovi1Click(TObject *Sender);
        void __fastcall Vzdialenoskcieu1Click(TObject *Sender);
        void __fastcall Sumavzdialenostkrobotoviakcieu1Click(
          TObject *Sender);
        void __fastcall Nhodnebezmetriky1Click(TObject *Sender);
        void __fastcall Oprograme1Click(TObject *Sender);
        void __fastcall toggleitemClick(TObject *Sender);
        void __fastcall ProgressGraphImageClick(TObject *Sender);
        void __fastcall Ovldanie1Click(TObject *Sender);
        void __fastcall ComPort1RxChar(TObject *Sender, int Count);
        void __fastcall RealTimerTimer(TObject *Sender);
        void __fastcall Popispolokbludiska1Click(TObject *Sender);
        void __fastcall AutoStepTimerRealTimer(TObject *Sender);
        void __fastcall ReleaseTimerTimer(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);


        void LoadGenotype();
        int RotateGenotype(int position);
        int GenerateGen(int position);
        void SetRecoveryMethod();
        String DecodeGen(int gen);
        void ShowGenotype();
        double Round2(float argument);
        void ResetProgressGraph(void);
        void GetDestinationCoordinates();
        void ShowModelObstacle(int x,int y);
        void ShowObstacle(int x,int y);
        void ShowTemp(int x,int y);
        void ShowFree(int x,int y);
        void ShowDestination();
        void InitializeArrayModel (int obstacles);
        void RefreshArrayModel();
        void ToggleObstacle (int X, int Y);
        void RefreshArray();
        float GetDistance(int X,int Y);
        int EvaluateSituation (int x,int y);
        void UpdateLog();
        void ShowRobot();
        void ClearArray();
        void SetNewDestination (int X, int Y);
        void InitializeSystem ();
        void ShowSmallSituation(int kod);
        int GetDistanceVector();
        void TryTurnLeft();
        void TryTurnRight();
        void TryMoveForward();
        void TryMoveBackward();
        int ExecuteSimulationStep();
        int ExecuteRealStep();
        int SearchKnowledgeBase (int SituationCode);
        String TellMeNextMovement(int _NextStepCode);
        int FindCheckTemp ();
        int CheckLab();
        void SetTemporaryTarget(int X,int Y);
        float GetDistanceToRobot(int X, int Y);
        int ValidatePosition(int X, int Y);
        float GetDistanceToTemp(int X, int Y);
        void StopAutoTimer();
        int GetDistanceToTempVector();
        void SetNearestTemporaryTarget(int X, int Y);
        int SuggestValidMovement(int X, int Y);
        void SetPrimaryMethod(void);
        void SetNearestToDestinationTemporaryTarget(int X, int Y);
        void SetRandomTemporaryTarget(int X, int Y);
        void SetMetricsMethod(void);
        void ShowUseless(int X, int Y);
        void FindUselessFields(void);
        int TryMoveForwardAndLeft(void);
        int TryMoveForwardAndRight(void);
        int TryMoveBackwardAndLeft(void);
        int TryMoveBackwardAndRight(void);
        void SetSomeTarget();
        int FindZone(int Width, int Height);
        void FindUselessZones(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
